#version 150

attribute vec3 aPosition;
attribute vec3 aNormal;

uniform mat4 uProjMatrix;
uniform mat4 uViewMatrix;
uniform mat4 uModelMatrix;

uniform vec3 uLightPos;

varying vec3 vNormal;
varying vec4 vPosition;
varying vec3 vWPosition;

void main() {	

  // First model transforms 
  vPosition = uModelMatrix* vec4(aPosition, 1.0);
  
  //save posiiton in world coords for frag shader
  vWPosition = vec3(vPosition);

  //fix the normal vector to reflect transform
  vNormal = vec3(transpose(inverse(uModelMatrix)) * vec4(aNormal, 1));

  //Camera and projection transform
  vPosition = uViewMatrix* vPosition;
  gl_Position = uProjMatrix*vPosition;
}
